# Gtk::SizeRequest Class Reference

TODO. More...

Inherits Glib::Interface.

Inherited by Gtk::Widget.

Collaboration diagram for Gtk::SizeRequest:
[legend]

List of all members.

## Public Member Functions

virtual | ~SizeRequest ()
GtkSizeRequest* | gobj ()
| Provides access to the underlying C GObject.
const GtkSizeRequest* | gobj () const
| Provides access to the underlying C GObject.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | get_width (int& minimum_width, int& natural_width) const
| Retrieves a widget's initial minimum and natural width.
void | get_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget's minimum and natural height if it would be given the specified width.
void | get_height (int& minimum_height, int& natural_height) const
| Retrieves a widget's initial minimum and natural height.
void | get_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget's minimum and natural width if it would be given the specified height.
void | get_size (Requisition& minimum_size, Requisition& natural_size)
| Retrieves the minimum and natural size of a widget taking into account the widget's preference for height-for-width management.

## Static Public Member Functions

static void | add_interface (GType gtype_implementer)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gtk::SizeRequest > | wrap (GtkSizeRequest* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

TODO.

Since gtkmm 3.0:

## Constructor & Destructor Documentation

virtual Gtk::SizeRequest::~SizeRequest | ( |  | ) | `[virtual]`

## Member Function Documentation

static void Gtk::SizeRequest::add_interface | ( | GType | gtype_implementer | ) | `[static]`

void Gtk::SizeRequest::get_height | ( | int & | minimum_height,
|  | int & | natural_height |
| ) |  |  | const

Retrieves a widget's initial minimum and natural height.

<note>

This call is specific to width-for-height requests.

</note>

Since gtkmm 3.0:

Parameters:

  | minimum_height | Location to store the minimum height, or `0`.
  | natural_height | Location to store the natural height, or `0`.

void Gtk::SizeRequest::get_height_for_width | ( | int | width,
|  | int & | minimum_height,
|  | int & | natural_height |
| ) |  |  | const

Retrieves a widget's minimum and natural height if it would be given the specified width.

Since gtkmm 3.0:

Parameters:

  | width | The width which is available for allocation.
  | minimum_height | Location for storing the minimum height, or `0`.
  | natural_height | Location for storing the natural height, or `0`.

SizeRequestMode Gtk::SizeRequest::get_request_mode | ( |  | ) | const

Gets whether the widget prefers a height-for-width layout or a width-for-height layout.

<note>

Gtk::Bin widgets generally propagate the preference of their child, container widgets need to request something either in context of their children or in context of their allocation capabilities.

</note>

Since gtkmm 3.0:

Returns:
  The Gtk::SizeRequestMode preferred by widget.

void Gtk::SizeRequest::get_size | ( | Requisition& | minimum_size,
|  | Requisition& | natural_size |
| ) |  |  |

Retrieves the minimum and natural size of a widget taking into account the widget's preference for height-for-width management.

This is used to retrieve a suitable size by container widgets which do not impose any restrictions on the child placement.

Since gtkmm 3.0:

Parameters:

  | minimum_size | Location for storing the minimum size, or `0`.
  | natural_size | Location for storing the natural size, or `0`.

void Gtk::SizeRequest::get_width | ( | int & | minimum_width,
|  | int & | natural_width |
| ) |  |  | const

Retrieves a widget's initial minimum and natural width.

<note>

This call is specific to height-for-width requests.

</note>

Since gtkmm 3.0:

Parameters:

  | minimum_width | Location to store the minimum width, or `0`.
  | natural_width | Location to store the natural width, or `0`.

void Gtk::SizeRequest::get_width_for_height | ( | int | height,
|  | int & | minimum_width,
|  | int & | natural_width |
| ) |  |  | const

Retrieves a widget's minimum and natural width if it would be given the specified height.

Since gtkmm 3.0:

Parameters:

  | height | The height which is available for allocation.
  | minimum_width | Location for storing the minimum width, or `0`.
  | natural_width | Location for storing the natural width, or `0`.

const GtkSizeRequest* Gtk::SizeRequest::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::AboutDialog, Gtk::AccelLabel, Gtk::Alignment, Gtk::Arrow, Gtk::AspectFrame, Gtk::Assistant, Gtk::Bin, Gtk::Box, Gtk::VBox, Gtk::HBox, Gtk::Button, Gtk::ButtonBox, Gtk::VButtonBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::CellView, Gtk::CheckButton, Gtk::CheckMenuItem, Gtk::ColorButton, Gtk::ColorSelection, Gtk::ColorSelectionDialog, Gtk::ComboBox, Gtk::ComboBoxEntry, Gtk::Container, Gtk::Dialog, Gtk::DrawingArea, Gtk::Entry, Gtk::EventBox, Gtk::Expander, Gtk::FileChooserButton, Gtk::FileChooserDialog, Gtk::FileChooserWidget, Gtk::Fixed, Gtk::FontButton, Gtk::FontSelection, Gtk::FontSelectionDialog, Gtk::Frame, Gtk::HandleBox, Gtk::IconView, Gtk::Image, Gtk::ImageMenuItem, Gtk::InfoBar, Gtk::Invisible, Gtk::Label, Gtk::Layout, Gtk::LinkButton, Gtk::Menu, Gtk::MenuBar, Gtk::MenuItem, Gtk::MenuShell, Gtk::MenuToolButton, Gtk::MessageDialog, Gtk::Misc, Gtk::Notebook, Gtk::OffscreenWindow, Gtk::Paned, Gtk::HPaned, Gtk::VPaned, Gtk::Plug, Gtk::ProgressBar, Gtk::RadioButton, Gtk::RadioMenuItem, Gtk::RadioToolButton, Gtk::Range, Gtk::RecentChooserDialog, Gtk::RecentChooserMenu, Gtk::RecentChooserWidget, Gtk::Ruler, Gtk::VRuler, Gtk::HRuler, Gtk::Scale, Gtk::VScale, Gtk::HScale, Gtk::ScaleButton, Gtk::Scrollbar, Gtk::VScrollbar, Gtk::HScrollbar, Gtk::ScrolledWindow, Gtk::Separator, Gtk::VSeparator, Gtk::HSeparator, Gtk::SeparatorMenuItem, Gtk::SeparatorToolItem, Gtk::Socket, Gtk::SpinButton, Gtk::Spinner, Gtk::Statusbar, Gtk::Table, Gtk::TearoffMenuItem, Gtk::TextView, Gtk::ToggleButton, Gtk::ToggleToolButton, Gtk::Toolbar, Gtk::ToolButton, Gtk::ToolItem, Gtk::ToolItemGroup, Gtk::ToolPalette, Gtk::TreeView, Gtk::Viewport, Gtk::VolumeButton, Gtk::Widget, Gtk::Window, Gtk::WrapBox, Gtk::PageSetupUnixDialog, and Gtk::PrintUnixDialog.

GtkSizeRequest* Gtk::SizeRequest::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented from Glib::Interface.

Reimplemented in Gtk::AboutDialog, Gtk::AccelLabel, Gtk::Alignment, Gtk::Arrow, Gtk::AspectFrame, Gtk::Assistant, Gtk::Bin, Gtk::Box, Gtk::VBox, Gtk::HBox, Gtk::Button, Gtk::ButtonBox, Gtk::VButtonBox, Gtk::HButtonBox, Gtk::Calendar, Gtk::CellView, Gtk::CheckButton, Gtk::CheckMenuItem, Gtk::ColorButton, Gtk::ColorSelection, Gtk::ColorSelectionDialog, Gtk::ComboBox, Gtk::ComboBoxEntry, Gtk::Container, Gtk::Dialog, Gtk::DrawingArea, Gtk::Entry, Gtk::EventBox, Gtk::Expander, Gtk::FileChooserButton, Gtk::FileChooserDialog, Gtk::FileChooserWidget, Gtk::Fixed, Gtk::FontButton, Gtk::FontSelection, Gtk::FontSelectionDialog, Gtk::Frame, Gtk::HandleBox, Gtk::IconView, Gtk::Image, Gtk::ImageMenuItem, Gtk::InfoBar, Gtk::Invisible, Gtk::Label, Gtk::Layout, Gtk::LinkButton, Gtk::Menu, Gtk::MenuBar, Gtk::MenuItem, Gtk::MenuShell, Gtk::MenuToolButton, Gtk::MessageDialog, Gtk::Misc, Gtk::Notebook, Gtk::OffscreenWindow, Gtk::Paned, Gtk::HPaned, Gtk::VPaned, Gtk::Plug, Gtk::ProgressBar, Gtk::RadioButton, Gtk::RadioMenuItem, Gtk::RadioToolButton, Gtk::Range, Gtk::RecentChooserDialog, Gtk::RecentChooserMenu, Gtk::RecentChooserWidget, Gtk::Ruler, Gtk::VRuler, Gtk::HRuler, Gtk::Scale, Gtk::VScale, Gtk::HScale, Gtk::ScaleButton, Gtk::Scrollbar, Gtk::VScrollbar, Gtk::HScrollbar, Gtk::ScrolledWindow, Gtk::Separator, Gtk::VSeparator, Gtk::HSeparator, Gtk::SeparatorMenuItem, Gtk::SeparatorToolItem, Gtk::Socket, Gtk::SpinButton, Gtk::Spinner, Gtk::Statusbar, Gtk::Table, Gtk::TearoffMenuItem, Gtk::TextView, Gtk::ToggleButton, Gtk::ToggleToolButton, Gtk::Toolbar, Gtk::ToolButton, Gtk::ToolItem, Gtk::ToolItemGroup, Gtk::ToolPalette, Gtk::TreeView, Gtk::Viewport, Gtk::VolumeButton, Gtk::Widget, Gtk::Window, Gtk::WrapBox, Gtk::PageSetupUnixDialog, and Gtk::PrintUnixDialog.

## Friends And Related Function Documentation

Glib::RefPtr< Gtk::SizeRequest > wrap | ( | GtkSizeRequest * | object,
|  | bool | take_copy = `false` |
| ) |  |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  | object | The C instance.
  | take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/sizerequest.h